#ifndef ELF_FLASH_H
#define ELF_FLASH_H 

#include "ELF.h"

#define MAX_OPENED_FILES 3

enum {
  TOS_EEPROM_MAX_PAGES = 2048,
  TOS_EEPROM_PAGE_SIZE = 264,
  TOS_EEPROM_PAGE_SIZE_LOG2 = 8 // For those who want to ignore the last 8 bytes
};

enum {
  TOS_EEPROM_ERASE,
  TOS_EEPROM_DONT_ERASE,
  TOS_EEPROM_PREVIOUSLY_ERASED
};

typedef uint16_t eeprompage_t;
typedef uint16_t eeprompageoffset_t; /* 0 to TOS_EEPROM_PAGE_SIZE - 1 */

typedef uint16_t flashpage_t;
typedef uint16_t flashpageoffset_t; /* 0 to TOS_EEPROM_PAGE_SIZE - 1 */


typedef eeprompage_t fileblock_t;
typedef eeprompageoffset_t fileblockoffset_t; /* 0 to IFS_PAGE_SIZE */

// typedef eeprompage_t flashpage_t;
typedef eeprompageoffset_t filepageoffset_t; /* 0 to IFS_PAGE_SIZE */

typedef uint8_t fileblockfoo_t; /* 0 to IFS_PAGE_SIZE - 1 */
typedef uint32_t filemeta_t;	/* Metadata version number */


//elf_inode.h
/*
#define MAJOR_NODE 0x01
#define MINOR_NODE 0x02
#define DIR_NODE  0x04

#define ELF_ROOT    0x08
#define ELF_FILE    0x01
#define ELF_DIR     0x04

#define NORMAL_NODE 0x00
#define RENAMED_NODE 0x01
#define OBSELETED_NODE 0x02
#define MODIFIED_NODE 0x03 
#define PHY_MAJOR_NODE 0x04

// #define FLAG_DIR_OFFSET 0x00

// need to change thess flags
// the order is wrong
#define FLAG_OBSELETED 0x80
#define FLAG_RENAMED 0x40
#define FLAG_MODIFIED 0x20
#define FLAG_RELIABLE_LOW 0x08
#define FLAG_RELIABLE_MID 0x10
#define FLAG_RELIABLE_HIGH 0x18


// elf_resource.h

#define PAGE_CACHES       10
// is the following two values appropriate ?
#define DEFAULT_MINFREE_THRESHOLD    200
#define DEFAULT_MAXDIRTY_THRESHOLD   1000  



// elf
#define PAGE_INODE_OFFSET 0
#define PAGE_INFO_OFFSET 256
#define PAGE_CRC_OFFSET 256
#define PAGE_FLAG_OFFSET 258
#define NEXT_PAGE_OFFSET 258
#define WRITE_COUNTER_OFFSET 260

#define NODE_END_FLAG 2
#define DIRTY_FLAG 3
#define FREE_FLAG  1
#define INUSE_FLAG  0

#define WRITE_CACHE FLASH_BUFFER_2
#define READ_CACHE FLASH_BUFFER_1

#define UNREACHABLE_PAGE 2500

#define ELF_GENERAL 0x1122
#define INODE_PAGE 0xAABB 
#define CHECKPOINT_PAGE 0xCCDD

#define FS_NUM_RFDS 3
*/

/*

// elf_file.h
#define ELF_SUCCESS  0x00
#define ELF_ENOSPC   0x02
#define ELF_EFULL    0x03
#define ELF_WRITE_FAIL 0x01

#define FILE_DELETED  0x01


struct file_descriptor{
  fmode_t flags;            // 1 byte
  elf_inode_cache_t *file;  // the file this descriptor points to 2 byte
  uint32_t curOffset;       // offset in the file    4 byte;
  elf_node_t *curNode;      // 2 bytes  
  uint16_t lastPg;          // 2 byte
  uint8_t lastByte;         // 1 byte
  //		remaining reserved byte for write descriptor?
} __attribute__((packed));
typedef struct file_descriptor elf_fd_t;


struct file_offset{
  elf_node_t *node;  
  uint16_t page;
  uint8_t inPgOffset;
  uint32_t offset;
} __attribute__((packed));
typedef struct file_offset elf_file_offset_t;

#define MAX_FILE_SIZE 500000 // 500 K is used temporarily
#define DEFAULT_INIT_FILE_SIZE 1024 // 4 pages for default allocated size
#define DATA_SIZE_PER_PAGE 256

#define ELF_FILE_END  0x01
#define ELF_FILE_CUR  0x02
#define ELF_FILE_SET  0x03

#define min(A,B) ( (A) < (B) ? (A):(B))

elf_fd_t fds[MAX_OPENED_FILES];

// elf_fm.h

struct elf_control
{
  elf_inode_cache_t *root;	      // The root directory file.  
  //  struct list_head *hash;	      // Hash table for finding files by ino. 
  //  uint16_t hash_len;	// The size of the hash table.  
  // uint16_t nextIno;		// Next inode number to use for new files.  
  // elf_resource_t *elfResource;
  //  mutex elfResourceLock;
  //  } __attribute__((packed));
  // typedef struct elf_control elf_control_t;
// elf_control_t *elfControl; // the only global structure

*/


#endif
